/* Humusoft data acquisition library.
 * Example that shows reading of analog input channels
 * using the function to read a single channel.
 */

/* Copyright 2002-2006 Humusoft s.r.o.; 2020-2021 J.Fojtik */

#include <stdio.h>

#include "hudaqlib.h"


const char *DAQ_DEVICE = "MF634";


int main(int argc, char *argv[])
{
HUDAQHANDLE h;
unsigned i;
unsigned NoAnalogIn;
double value;

  if(argc >= 2) DAQ_DEVICE=argv[1];

	/* Open a handle to the first MF624 device in the system. */
  h = HudaqOpenDevice(DAQ_DEVICE, 1, 0);
  if(h==0)
  {
    printf("\nData acquisition device %s not found.\n",DAQ_DEVICE);
    return(-1);
  }

  NoAnalogIn = HudaqGetParameter(h,0,HudaqAINUMCHANNELS);

	/* Read all the analog inputs in a loop, print their values. */
  for(i=0; i<NoAnalogIn; i++)
  {
    value = HudaqAIRead(h,i);
    printf("Analog channel %u, value read %fV.\n", i, value);
  }

	/* Close the device handle. */
  HudaqCloseDevice(h);

  return(0);
}
