/* Data acquisition library.
 *
 * Example that shows IRQ system functionality.
 *
 *   This WILL NOT work with original Humusoft's library!
 * Original Humusoft driver does not support IRQ.
 * Windows only.
 */

/* Copyright 2021 J.Fojtik */

#include <stdio.h>
#include <Windows.h>

#include "hudaqlib.h"


int main(int argc, char* argv[])
{
HUDAQHANDLE h;
unsigned i;
int value, value2;
unsigned ret;
const char *CardOpened;

  printf("Code started");

	/* Open a handle to the first MF624 device in the system */
//  CardOpened = "PCD-8006";
//  h = HudaqOpenDevice("PCD-8006", 1, 0);
//  if(h==0)
  {
    CardOpened = "PCD-7006C";
    h = HudaqOpenDevice(CardOpened, 1, 0);
  }
  if(h==0)
  {
    CardOpened = "PCD-7004";
    h = HudaqOpenDevice(CardOpened, 1, 0);
  }

  if(h==0)
  {
    printf("\nData acquisition device PCD-7006C or PCD-7004 not found.\n");
    return(-1);
  }
  printf("\nDevice %s succesfully opened.", CardOpened);

  ret = HudaqPWMWrite(h,0,10,0.5);
  if(ret!=HUDAQSUCCESS)
    printf("\nCannot write to PWM channel 0, error %d.\n",ret);

  value = HudaqCtrRead(h,0);
  Sleep(5);
  value2 = HudaqCtrRead(h,0);

  if(value == value2)
  {
    Sleep(3);
    value2 = HudaqCtrRead(h,0);
    if(value == value2)
    {
      printf("\nCounter does not work %d should be different from %d.\n", value, value2);
      //HudaqCloseDevice(h);
      //return -2;
    }
  }


  printf("\nIRQ before enable - status %d, IRQ counter %u.", 
          (int)HudaqGetParameter(h,0,HudaqIrqSTATUS), (unsigned)HudaqGetParameter(h,0,HudaqIrqNUMCOUNTER));
  HudaqSetParameter(h,0xFFFFFFFF,HudaqIrqENABLE,1);
  printf("\nIRQ enabled - status %d, IRQ counter %u.", 
          (int)HudaqGetParameter(h,0,HudaqIrqSTATUS), (unsigned)HudaqGetParameter(h,0,HudaqIrqNUMCOUNTER));
  
  for(i=1; i<5; i++)
  {
    ret = HudaqWaitForIrq(h, 5001, 1);
    if(HUDAQIrqPending==ret)
    {
      printf("\nPending IRQ cleared, trying to continue waiting.");
      HudaqSetParameter(h,0,HudaqIrqSTATUS,0xFF);		// Clear IRQ flags
      ret = HudaqWaitForIrq(h, 5001, 1);
    }

    if(HUDAQSUCCESS!=ret)
    {
      printf("\nIRQ failed to catch, error %d, status %d, IRQ counted %u.", ret,
            (int)HudaqGetParameter(h,0,HudaqIrqSTATUS),
            (unsigned)HudaqGetParameter(h,0,HudaqIrqNUMCOUNTER));   
    }
    else
      printf("\nIRQ status %d, IRQ counter %u.", 
          (int)HudaqGetParameter(h,0,HudaqIrqSTATUS), (unsigned)HudaqGetParameter(h,0,HudaqIrqNUMCOUNTER));

    ret = HudaqSetParameter(h,0,HudaqIrqSTATUS,0xFF);		// Clear IRQ flags
    if(ret != HUDAQSUCCESS)
    {
      printf("\nHudaqSetParameter failed with result %d.", ret);
    }
  }

	/* Close the device handle */
  HudaqCloseDevice(h);

  return(0);
}
